/*
 * HttpdListener.java
 *
 * Creado el 18 de diciembre de 2007, 14:26
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.minhttpd;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;

/**
 *
 * @author avelino
 */
public class HttpListener implements Runnable {
    private boolean alive = true;
    private ServerSocket serverSocket = null;
    private HttpProcessor httpProcessor = null;

    public HttpListener(int listenPort, HttpProcessor httpProcessor) {
        try {
            this.serverSocket = new ServerSocket(listenPort);
            this.serverSocket.setSoTimeout(100);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        this.httpProcessor = httpProcessor;
    }

    public void run() {
        try {
            while (this.alive) {
                // System.out.println("waiting for a connection");
                Socket socket = null;
                try {
                    socket = this.serverSocket.accept();
                    System.out.println("connection from " + socket.getInetAddress().getHostAddress());
                    Thread t = new Thread(new HttpDispatcher(socket, this.httpProcessor));
                    t.start();
                }
                catch (SocketTimeoutException toe) {
                    // System.out.println("--- SocketTimeoutException");
                }
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Stop this listen thread
     */
    public void stop() {
        this.alive = false;
        System.out.println("alive = " + this.alive);
    }
}
