/*
 * HttpRequest.java
 *
 * Creado el 17 de diciembre de 2007, 9:36
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.minhttpd;

import java.util.Hashtable;

/**
 *
 * @author avelino
 */
public class HttpRequest {
    public String method;
    public String resource;
    public String protocol;
    public Hashtable<String,String> header;
    public Hashtable<String,String> variables;
    public byte[] postData;
    public Hashtable<String,String> cookie = new Hashtable<String,String>();
    
    public HttpRequest(String method, String resource, String protocol, Hashtable<String,String> header, Hashtable<String,String> variables, byte[] postData) {
        this.method = method;
        this.resource = resource;
        this.protocol = protocol;
        this.header = header;
        this.variables = variables;
        this.postData = postData;
        String cookieValue = this.header.get("Cookie");
        if (cookieValue != null) {
            HttpDispatcher.parseVariableString(cookieValue, this.cookie, ";");
            //System.out.println("HttpRequest.init:  Cookie=" + cookieValue);
        }
    }
}
