/*
 * MinHttpd.java
 *
 * Creado el 14 de diciembre de 2007, 9:50
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package com.mhpsc.minhttpd;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JFrame;

/**
 *
 * @author avelino
 */
public class MinHttpd {

    /**
     * Launch an HTTP server (an HttpListener object).
     *
     * @param listenPort Port where to listen.
     * @param httpProcessor The object which will process the HTTP requests and will generate the HTTP responses.
     * @return
     */
    public static HttpListener launchHttpServer(int listenPort, HttpProcessor httpProcessor) {
        HttpListener ret = new HttpListener(listenPort, httpProcessor);
        Thread t = new Thread(ret);
        t.start();
        return ret;
    }
    
    public static void main(String[] args) {
        try {
            HttpListener httpServer = null;
            while (true) {
                System.out.println("> ");
                byte[] raw = new byte[1024];
                int readed = System.in.read(raw);
                String command = new String(raw, 0, readed, "ISO-8859-1");
                command = command.trim();
                if (command.compareToIgnoreCase("start") == 0)
                    httpServer = launchHttpServer(1799, new SampleHttpProcessor());
                else if (command.compareToIgnoreCase("stop") == 0)
                    httpServer.stop();
                else if (command.compareToIgnoreCase("quit") == 0)
                    System.exit(0);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
